package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityAnnualAwardConfigDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 周年庆奖励榜单配置表 Mapper
 */
@Mapper
@Repository
public interface ActivityAnnualAwardConfigDAO {

    /**
     * 插入数据
     */
    int insert(ActivityAnnualAwardConfigDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<ActivityAnnualAwardConfigDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(ActivityAnnualAwardConfigDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    ActivityAnnualAwardConfigDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    List<ActivityAnnualAwardConfigDO> selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<ActivityAnnualAwardConfigDO> selectPageList(QueryWrapper qw);

    /**
     * 根据ids获得 DO Map
     *
     * @param ids id集合
     * @return Map<主键, DO对象>
     */
    @MapKey("hisId")
    Map<Long, ActivityAnnualAwardConfigDO> selectMapByIds(@Param("ids") Collection ids);

    /**
     * 获取奖品配置
     *
     * @param activityId
     * @param rankType
     * @return
     */
    List<ActivityAnnualAwardConfigDO> getAwardConfigList(@Param("activityId") Long activityId, @Param("rankType") Integer rankType);
}