package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityAnnualAwardGiveHisDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 用户礼物发放记录 Mapper
 */
@Mapper
@Repository
public interface ActivityAnnualAwardGiveHisDAO {

    /**
     * 插入数据
     */
    int insert(ActivityAnnualAwardGiveHisDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<ActivityAnnualAwardGiveHisDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(ActivityAnnualAwardGiveHisDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    ActivityAnnualAwardGiveHisDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    List<ActivityAnnualAwardGiveHisDO> selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<ActivityAnnualAwardGiveHisDO> selectPageList(QueryWrapper qw);

    /**
     * 根据ids获得 DO Map
     *
     * @param ids id集合
     * @return Map<主键, DO对象>
     */
    @MapKey("hisId")
    Map<Long, ActivityAnnualAwardGiveHisDO> selectMapByIds(@Param("ids") Collection ids);

    /**
     * 获取记录ID
     *
     * @param userId
     * @param activityId
     * @param rankType
     * @param itemId
     * @param dateInt
     * @return
     */
    Long getGiveHisId(@Param("userId") Long userId, @Param("activityId") Long activityId,
                      @Param("rankType") Integer rankType, @Param("itemId") Long itemId, @Param("dateInt") Integer dateInt);
}