package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityAnnualAwardItemDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 周年庆奖励奖项item Mapper
 */
@Mapper
@Repository
public interface ActivityAnnualAwardItemDAO {

    /**
     * 插入数据
     */
    int insert(ActivityAnnualAwardItemDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<ActivityAnnualAwardItemDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(ActivityAnnualAwardItemDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    ActivityAnnualAwardItemDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    List<ActivityAnnualAwardItemDO> selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<ActivityAnnualAwardItemDO> selectPageList(QueryWrapper qw);

    /**
     * 根据ids获得 DO Map
     *
     * @param ids id集合
     * @return Map<主键, DO对象>
     */
    @MapKey("hisId")
    Map<Long, ActivityAnnualAwardItemDO> selectMapByIds(@Param("ids") Collection ids);

    /**
     * 获取奖品列表
     *
     * @param activityId
     * @param rankType
     * @return
     */
    List<ActivityAnnualAwardItemDO> getAwardItemList(@Param("activityId") Long activityId, @Param("rankType") Integer rankType);
}