package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityBarrageDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import javax.ws.rs.POST;
import java.util.List;

/**
 * 七夕活动弹幕表 Mapper
 */
@Mapper
@Repository
public interface ActivityBarrageDAO {

    /**
     * 插入数据
     */
    int insert(ActivityBarrageDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<ActivityBarrageDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(ActivityBarrageDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    ActivityBarrageDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    ActivityBarrageDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<ActivityBarrageDO> selectPageList(QueryWrapper qw);

    /**
     * 获取最新一条记录
     *
     * @param userId
     * @param activityId
     * @return
     */
    ActivityBarrageDO getLastBarrage(@Param("userId") Long userId, @Param("activityId") Long activityId);

    /**
     * 获取最新的50条
     *
     * @param activityId
     * @return
     */
    List<ActivityBarrageDO> getBarrageList(@Param("activityId") Long activityId, @Param("yesterday") Long yesterday);
}