package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityBroadcastHisDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 活动全局广播消息记录 Mapper
 */
@Mapper
@Repository
public interface ActivityBroadcastHisDAO {

    /**
     * 插入数据
     */
    int insert(ActivityBroadcastHisDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<ActivityBroadcastHisDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(ActivityBroadcastHisDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    ActivityBroadcastHisDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    ActivityBroadcastHisDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<ActivityBroadcastHisDO> selectPageList(QueryWrapper qw);

    /**
     * 获取活动群体广播总数
     *
     * @param sendUserId
     * @param receiveUserId
     * @param activityId
     * @return
     */
    int getSendBroadcastCount(@Param("sendUserId") Long sendUserId, @Param("receiveUserId") Long receiveUserId, @Param("activityId") Long activityId);
}