package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityCollectDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Author jiangxiaowei
 * @DateTime 2020/9/28 10:49
 * @Description 收集活动
 */
@Mapper
@Repository
public interface ActivityCollectDAO {


    /**
     * 获取收集活动
     *
     * @param activityId
     * @return
     */
    List<ActivityCollectDO> selectCollects(@Param("activityId") Long activityId);

    /**
     * 根据id查询
     *
     * @param collectId
     * @return
     */
    ActivityCollectDO selectById(@Param("collectId") String collectId);

    /**
     * 判断活动是否存在
     *
     * @param collectId
     */
    int countById(@Param("collectId") String collectId);

    /**
     * 判断是否领取
     *
     * @param collectId
     * @param userId
     * @return
     */
    int countByUserId(@Param("collectId") String collectId, @Param("userId") Long userId);

    /**
     * 通过ID获取列表
     *
     * @param activityIds
     * @return
     */
    List<ActivityCollectDO> getActivityCollectList(@Param("activityIds") List<Long> activityIds);
}
