package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.activity.ActivityGiftRankUser;
import com.starbuds.server.common.pojo.activity.RankItem;
import com.starbuds.server.common.pojo.db.ActivityGiftRankUserDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 备注
 *
 * @author Lay
 * @date 2020/6/23
 */
@Mapper
@Repository
public interface ActivityGiftRankUserDAO {
    /**
     * 创建或增加
     *
     * @param activityGiftRankUserDO
     * @return
     */
    int insertOrIncrease(ActivityGiftRankUserDO activityGiftRankUserDO);

    /**
     * 查询排行榜
     *
     * @param activityId
     * @param num
     * @return
     */
    List<ActivityGiftRankUser> selectAll(@Param("activityId") Long activityId, @Param("num") int num);

    /**
     * 获取送出去
     *
     * @param activityId
     * @param userId
     * @return
     */
    RankItem selectByActivityId(@Param("activityId") Long activityId, @Param("userId") Long userId);
}
