package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityGiftsRankReceiveDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 多礼物活动收礼榜单，按天分隔。收礼人当天只有一条记录 Mapper
 */
@Mapper
@Repository
public interface ActivityGiftsRankReceiveDAO {

    /**
     * 插入数据
     */
    int insert(ActivityGiftsRankReceiveDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<ActivityGiftsRankReceiveDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(ActivityGiftsRankReceiveDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    ActivityGiftsRankReceiveDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    ActivityGiftsRankReceiveDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<ActivityGiftsRankReceiveDO> selectPageList(QueryWrapper qw);

    /**
     * 根据ids获得 DO Map
     *
     * @param ids id集合
     * @return Map<主键, DO对象>
     */
    @MapKey("activityGiftsRankReceiveId")
    Map<Long, ActivityGiftsRankReceiveDO> selectMapByIds(@Param("ids") Collection ids);

    /**
     * 查询当日数据是否已存在
     */
    boolean isExistCurrentDay(QueryWrapper qw);

    /**
     * 更新total
     */
    int updateTotal(@Param("total") Long total,
                    @Param("activityId") Long activityId,
                    @Param("receiveUserId") Long receiveUserId,
                    @Param("createDate") Long createDate,
                    @Param("timestamp") Long timestamp);
}