package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.activity.GrabPlayerWinQuantity;
import com.starbuds.server.common.pojo.db.ActivityGrabPeriodItemDO;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 备注
 *
 * @author Lay
 * @date 2021/3/29
 */
@Mapper
@Repository
public interface ActivityGrabPeriodItemDAO {
    /**
     * 创建记录
     *
     * @param activityGrabPeriodItemDO
     * @return
     */
    @Insert("INSERT INTO tb_activity_grab_period_item(periodId, userId, joinTime, winQuantity)VALUES(#{periodId}, #{userId}, #{joinTime}, #{winQuantity})")
    int insert(ActivityGrabPeriodItemDO activityGrabPeriodItemDO);

    /**
     * 查询参与玩家标识列表
     *
     * @param periodId
     * @return
     */
    @Select("SELECT userId FROM tb_activity_grab_period_item WHERE periodId = #{periodId}")
    List<Long> selectUserIds(long periodId);

    /**
     * 更新数量
     *
     * @param periodId
     * @param list
     * @return
     */
    int updateWinQuantity(@Param("periodId") long periodId, @Param("list") List<ActivityGrabPeriodItemDO> list);

    /**
     * 查询数量列表
     *
     * @param periodIds
     * @return
     */
    List<GrabPlayerWinQuantity> selectWinQuantities(@Param("periodIds") List<Long> periodIds);

    /**
     * 统计玩家数量
     *
     * @param periodId
     * @return
     */
    @Select("SELECT COUNT(0) FROM tb_activity_grab_period_item WHERE periodId = #{periodId}")
    int countPlayers(long periodId);

    /**
     * 统计是否参与
     *
     * @param periodId
     * @param userId
     * @return
     */
    @Select("SELECT COUNT(0) FROM tb_activity_grab_period_item WHERE periodId = #{periodId} AND userId = #{userId}")
    int countById(@Param("periodId") long periodId, @Param("userId") long userId);
}
