package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityHeadlineConfigDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

/**
 * 备注
 *
 * @author Lay
 * @date 2020/12/28
 */
@Mapper
@Repository
public interface ActivityHeadlineConfigDAO {
    /**
     * 根据主键统计
     *
     * @param configId
     * @return
     */
    @Select("SELECT COUNT(0) FROM tb_activity_headline_config WHERE configId = #{configId}")
    int countById(long configId);

    /**
     * 根据时间表达式查询
     *
     * @param timeExp
     * @return
     */
    @Select("SELECT configId, activityId, configName, timeExp, timeDuration, rewards, priceType, price, status FROM tb_activity_headline_config WHERE timeExp = #{timeExp} AND status > 0 LIMIT 1")
    ActivityHeadlineConfigDO selectByTimeExp(String timeExp);

    /**
     * 根据主键查询
     *
     * @param configId
     * @return
     */
    @Select("SELECT configId, activityId, configName, timeExp, timeDuration, rewards, priceType, price, status FROM tb_activity_headline_config WHERE configId = #{configId} AND status > 0")
    ActivityHeadlineConfigDO selectById(long configId);
}
