package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.activity.ActivityHeadlinePeriod;
import com.starbuds.server.common.pojo.activity.HeadlineLotteryWinnerHisVO;
import com.starbuds.server.common.pojo.db.ActivityHeadlinePeriodDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 备注
 *
 * @author Lay
 * @date 2020/12/28
 */
@Mapper
@Repository
public interface ActivityHeadlinePeriodDAO {
    /**
     * 根据主键统计
     *
     * @param configId
     * @param periodId
     * @return
     */
    @Select("SELECT COUNT(0) FROM tb_activity_headline_period WHERE configId = #{configId} AND periodId = #{periodId}")
    int countById(@Param("configId") long configId, @Param("periodId") int periodId);

    /**
     * 根据主键查询
     *
     * @param configId
     * @param periodId
     * @return
     */
    @Select("SELECT configId, periodId, periodStatus, usersCount, timesCount, periodRewardConfig, createTime, overTime, winnerItemId, priceType, price FROM tb_activity_headline_period WHERE configId = #{configId} AND periodId = #{periodId}")
    ActivityHeadlinePeriodDO selectById(@Param("configId") long configId, @Param("periodId") int periodId);

    /**
     * 根据主键查询
     *
     * @param configId
     * @param periodId
     * @return
     */
    ActivityHeadlinePeriod selectPeriodById(@Param("configId") long configId, @Param("periodId") int periodId);

    /**
     * 更新
     *
     * @param period
     * @param wherePeriodStatus
     * @return
     */
    int updateAfterOver(@Param("period") ActivityHeadlinePeriodDO period, @Param("wherePeriodStatus") int wherePeriodStatus);

    /**
     * 查询往期中奖记录
     *
     * @param activityId
     * @return
     */
    List<HeadlineLotteryWinnerHisVO> selectWinnerHisList(@Param("activityId") Long activityId);
}
