package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityHeadlinePeriodItemDO;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

/**
 * 备注
 *
 * @author Lay
 * @date 2020/12/28
 */
@Mapper
@Repository
public interface ActivityHeadlinePeriodItemDAO {
    /**
     * 创建记录
     *
     * @param activityHeadlinePeriodItemDO
     * @return
     */
    @Insert("INSERT INTO tb_activity_headline_period_item(itemId, periodId, configId, userId, content, createTime) VALUES (#{itemId}, #{periodId}, #{configId}, #{userId}, #{content}, #{createTime})")
    int insert(ActivityHeadlinePeriodItemDO activityHeadlinePeriodItemDO);

    /**
     * 统计参与用户数
     *
     * @param configId
     * @param periodId
     * @return
     */
    @Select("SELECT COUNT(DISTINCT userId) FROM tb_activity_headline_period_item WHERE configId = #{configId} AND periodId = #{periodId}")
    int countUsers(@Param("configId") long configId, @Param("periodId") int periodId);

    /**
     * 统计参与次数
     *
     * @param configId
     * @param periodId
     * @return
     */
    @Select("SELECT COUNT(0) FROM tb_activity_headline_period_item WHERE configId = #{configId} AND periodId = #{periodId}")
    int countTimes(@Param("configId") long configId, @Param("periodId") int periodId);

    /**
     * 查询序号
     *
     * @param configId
     * @param periodId
     * @param limit
     * @return
     */
    @Select("SELECT itemId, periodId, configId, userId, content, createTime FROM tb_activity_headline_period_item WHERE configId = #{configId} AND periodId = #{periodId} ORDER BY itemId DESC LIMIT #{limit}, 1")
    ActivityHeadlinePeriodItemDO selectItemByIndex(@Param("configId") long configId, @Param("periodId") int periodId, @Param("limit") int limit);
}
