package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityLotteryDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 备注
 *
 * @author Lay
 * @date 2020/2/18
 */
@Mapper
@Repository
public interface ActivityLotteryDAO {
    /**
     * 根据 id 查询
     *
     * @param lotteryId
     * @return
     */
    ActivityLotteryDO selectById(@Param("lotteryId") String lotteryId);

    /**
     * 查询奖项
     *
     * @param lotteryId
     * @return
     */
    String selectRewards(@Param("lotteryId") String lotteryId);

    /**
     * 查询id是否存在
     *
     * @param lotteryId
     * @return
     */
    int countById(@Param("lotteryId") String lotteryId);

    /**
     * 通过Id获取列表
     *
     * @param activityIds
     * @return
     */
    List<ActivityLotteryDO> getActivityLotteryList(@Param("activityIds") List<Long> activityIds);

    /**
     * 通过活动ID获取抽奖活动列表
     *
     * @param activityId
     * @return
     */
    List<ActivityLotteryDO> getLotteryByActivityId(@Param("activityId") Long activityId);
}
