package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityTriggerDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 备注
 *
 * @author Lay
 * @date 2020/1/18
 */
@Mapper
@Repository
public interface ActivityTriggerDAO {
    /**
     * 根据事件查询
     *
     * @param triggerEvent
     * @param curTime
     * @return
     */
    List<ActivityTriggerDO> selectByEvent(@Param("triggerEvent") Integer triggerEvent, @Param("curTime") long curTime);

    /**
     * 根据 id 列表查询
     *
     * @param list
     * @return
     */
    List<ActivityTriggerDO> selectActionsByIds(List<Long> list);
}
