package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.ActivityWeekDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Author jiangxiaowei
 * @DateTime 2021/1/25 16:47
 * @Description 周星活动
 */
@Mapper
@Repository
public interface ActivityWeekDAO {

    /**
     * 获取周星活动
     *
     * @param activityId
     * @param date
     * @return
     */
    List<ActivityWeekDO> selectByActivityIdAndDate(@Param("activityId") Long activityId, @Param("date") Long date);

    /**
     * 获取上期活动
     *
     * @return
     */
    ActivityWeekDO selectLast();

    /**
     * 获取周星礼物
     *
     * @return
     */
    String selectWeekGifts();

    /**
     * 获取周星礼物  上期
     *
     * @return
     */
    String selectLastWeekGifts();

    /**
     * 获取周星标签id
     *
     * @return
     */
    Long selectTagId();

    /**
     * 根据id获取开始日期
     *
     * @param weekId
     * @return
     */
    Long selectStartDateById(@Param("weekId") String weekId);

}
