package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.DailySignInDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 备注
 *
 * @author Lay
 * @date 2020/9/23
 */
@Mapper
@Repository
public interface DailySignInDAO {
    /**
     * 创建记录
     *
     * @param dailySignInDO
     * @return
     */
    int insert(DailySignInDO dailySignInDO);

    /**
     * 根据时间统计
     *
     * @param dateNum
     * @param userId
     * @return
     */
    int countById(@Param("dateNum") Integer dateNum, @Param("userId") Long userId);

    /**
     * 根据日期范围查询
     *
     * @param userId
     * @param beginDate
     * @param endDate
     * @return
     */
    List<DailySignInDO> selectByDateRange(@Param("userId") Long userId, @Param("beginDate") Integer beginDate, @Param("endDate") Integer endDate);
}
