package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.activity.GiftAirRankItem;
import com.starbuds.server.common.pojo.db.GiftAirHisDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Author jiangxiaowei
 * @DateTime 2021/6/9 15:44
 * @Description 欧气榜持久层
 */
@Mapper
@Repository
public interface GiftAirHisDAO {

    /**
     * 批量写入
     *
     * @param list
     * @return
     */
    int batchInsert(@Param("list") List<GiftAirHisDO> list);

    /**
     * 获取欧气榜
     *
     * @param num
     * @param startTime
     * @param endTime
     * @return
     */
    List<GiftAirRankItem> selectGiftAirRank(@Param("num") int num, @Param("startTime") Long startTime, @Param("endTime") Long endTime);

    /**
     * 获取欧皇
     *
     * @param startTime
     * @param endTime
     * @return
     */
    GiftAirRankItem selectGiftAirTop(@Param("startTime") Long startTime, @Param("endTime") Long endTime);
}
