package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;
import com.starbuds.server.common.pojo.db.LotteryGameConfigDO;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 抽奖游戏配置 Mapper
 */
@Mapper
@Repository
public interface LotteryGameConfigDAO {

    /**
     * 插入数据
     */
    int insert(LotteryGameConfigDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<LotteryGameConfigDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(LotteryGameConfigDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    LotteryGameConfigDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    LotteryGameConfigDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<LotteryGameConfigDO> selectPageList(QueryWrapper qw);

}