package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;
import com.starbuds.server.common.pojo.db.LotteryGameTimerDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Mapper
 */
@Mapper
@Repository
public interface LotteryGameTimerDAO {

    /**
     * 插入数据
     */
    int insert(LotteryGameTimerDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<LotteryGameTimerDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(LotteryGameTimerDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    LotteryGameTimerDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    LotteryGameTimerDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<LotteryGameTimerDO> selectPageList(QueryWrapper qw);

    void updateStatistic(@Param("timerId") Long timerId, @Param("joinNum") Integer joinNum,
                         @Param("rewardNum") Integer rewardNum, @Param("giveRewardTotal") Long giveRewardTotal,
                         @Param("leftTotal") Long leftTotal);

    /**
     * 查询正在进行中的抽奖活动
     *
     * @return
     */
    @Select("SELECT timerId " +
            "FROM tb_lottery_game_timer " +
            // 状态 0未开启 1进行中 2已结束 LotteryGameTimerStatusEnum
            "WHERE status = 1 ")
    List<Long> selectInProgressingTimerIds();
}