package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.LotteryGameUserQualificationHisDO;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

/**
 * 抽奖活动中用户获取的抽奖资格 Mapper
 */
@Mapper
@Repository
public interface LotteryGameUserQualificationHisDAO {

    /**
     * 查询数据是否存在
     *
     * @param snapId
     * @param userId
     * @return
     */
    @Select("SELECT 1 " +
            "FROM tb_lottery_game_user_qualification_his " +
            "WHERE snapId = #{snapId} " +
            "AND userId = #{userId} " +
            "LIMIT 1")
    Integer selectExistBySnapIdUserId(@Param("snapId") Long snapId, @Param("userId") Long userId);

    /**
     * 插入数据
     */
    @Insert("INSERT INTO tb_lottery_game_user_qualification_his " +
            "(hisId,snapId,userId,isEffective,createTime) " +
            "VALUES " +
            "(#{hisId},#{snapId},#{userId},#{count},#{createTime})")
    int insert(LotteryGameUserQualificationHisDO po);

}
