package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.RtcRoomAdvanceDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Set;

/**
 * 活动房间晋级表 Mapper
 */
@Mapper
@Repository
public interface RtcRoomAdvanceDAO {

    /**
     * 插入数据
     */
    int insert(RtcRoomAdvanceDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<RtcRoomAdvanceDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(RtcRoomAdvanceDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    RtcRoomAdvanceDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    RtcRoomAdvanceDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<RtcRoomAdvanceDO> selectPageList(QueryWrapper qw);

    Set<Long> getPromiseRoomIds(@Param("activityId") Long activityId);

    int getCountBySubActId(@Param("subActivityId") Long subActivityId);

    int getFinalFlagCount(@Param("subActivityId") Long subActivityId);
}