package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.RtcRoomBorderDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Set;

/**
 * Mapper
 */
@Mapper
@Repository
public interface RtcRoomBorderDAO {

    /**
     * 插入数据
     */
    int insert(RtcRoomBorderDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<RtcRoomBorderDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(RtcRoomBorderDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    RtcRoomBorderDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    RtcRoomBorderDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<RtcRoomBorderDO> selectPageList(QueryWrapper qw);

    List<RtcRoomBorderDO> getRtcRoomBorderList(@Param("roomIds") Set<Long> roomIds, @Param("now") Long now);

    String getRtcRoomBorder(@Param("roomId") Long roomId, @Param("now") Long now);
}