package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.UserActivitiesLevelHisDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * Mapper
 */
@Mapper
@Repository
public interface UserActivitiesLevelHisDAO {

    /**
     * 插入数据
     */
    int insert(UserActivitiesLevelHisDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<UserActivitiesLevelHisDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(UserActivitiesLevelHisDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    UserActivitiesLevelHisDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    List<UserActivitiesLevelHisDO> selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<UserActivitiesLevelHisDO> selectPageList(QueryWrapper qw);

    /**
     * 根据ids获得 DO Map
     *
     * @param ids id集合
     * @return Map<主键, DO对象>
     */
    @MapKey("hisId")
    Map<Long, UserActivitiesLevelHisDO> selectMapByIds(@Param("ids") Collection ids);

    /**
     * 查询用户当前等级
     *
     * @param qw
     * @return
     */
    UserActivitiesLevelHisDO selectUserLevel(QueryWrapper qw);
}