package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.UserActivityScoreDO;
import com.starbuds.server.common.pojo.db.UserActivityScoreDetailDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 积分详情表 Mapper
 */
@Mapper
@Repository
public interface UserActivityScoreDetailDAO {

    /**
     * 插入数据
     */
    int insert(UserActivityScoreDetailDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<UserActivityScoreDetailDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(UserActivityScoreDetailDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    UserActivityScoreDetailDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    UserActivityScoreDetailDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<UserActivityScoreDetailDO> selectPageList(QueryWrapper qw);

    /**
     * 获取时间排行
     *
     * @param activityId
     * @param dayBegin
     * @param dayEnd
     * @return
     */
    List<UserActivityScoreDO> getUserDayRankList(@Param("activityId") Long activityId, @Param("dayBegin") Long dayBegin, @Param("dayEnd") Long dayEnd, @Param("limit") Integer limit);

    /**
     * 获取用户分数
     *
     * @param activityId
     * @param userId
     * @param dayBegin
     * @param dayEnd
     * @return
     */
    Long getUserScore(@Param("activityId") Long activityId, @Param("userId") Long userId,
                      @Param("dayBegin") Long dayBegin, @Param("dayEnd") Long dayEnd);

    /**
     * 检查是否之前存在记录
     *
     * @param activityId
     * @param orderId
     * @return
     */
    Integer getCount(@Param("activityId") Long activityId, @Param("orderId") Long orderId, @Param("userId") Long userId, @Param("exUserId") Long exUserId);
}
