package com.starbuds.server.service.activity.dao;

import com.starbuds.server.common.pojo.db.UserBagRewardCostHisDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 用户使用收到礼物兑换记录 Mapper
 */
@Mapper
@Repository
public interface UserBagRewardCostHisDAO {

    /**
     * 插入数据
     */
    int insert(UserBagRewardCostHisDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<UserBagRewardCostHisDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(UserBagRewardCostHisDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    UserBagRewardCostHisDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    UserBagRewardCostHisDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<UserBagRewardCostHisDO> selectPageList(QueryWrapper qw);

    /**
     * 查询用户访问频率
     *
     * @param userId
     * @param activityId
     * @param giftIds
     * @return
     */
    List<UserBagRewardCostHisDO> getUserCostHis(@Param("userId") Long userId, @Param("activityId") Long activityId, @Param("giftIds") List<Long> giftIds);
}