package com.starbuds.server.service.activity.impl;

import com.starbuds.server.common.pojo.db.ActivityAnnualAwardGiveHisDO;
import com.starbuds.server.service.activity.provider.ActivityAnnualAwardGiveHisProvider;
import com.starbuds.server.common.pojo.activity.qo.ActivityAnnualAwardGiveHisPageListQO;

import com.starbuds.server.common.pojo.api.PageList;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import com.starbuds.server.common.service.activity.ActivityAnnualAwardGiveHisService;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.dubbo.config.annotation.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 用户礼物发放记录
 */
@Service(version = "1.0.0")
@Slf4j
public class ActivityAnnualAwardGiveHisServiceImpl implements ActivityAnnualAwardGiveHisService {

    @Resource
    private ActivityAnnualAwardGiveHisProvider activityAnnualAwardGiveHisProvider;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ActivityAnnualAwardGiveHisDO create(ActivityAnnualAwardGiveHisDO po) {
        return activityAnnualAwardGiveHisProvider.create(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createBatch(List<ActivityAnnualAwardGiveHisDO> list) {
        return activityAnnualAwardGiveHisProvider.createBatch(list);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createOrUpdate(ActivityAnnualAwardGiveHisDO po) {
        return activityAnnualAwardGiveHisProvider.createOrUpdate(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean updateById(ActivityAnnualAwardGiveHisDO po) {
        return activityAnnualAwardGiveHisProvider.updateById(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean update(UpdateWrapper uw) {
        return activityAnnualAwardGiveHisProvider.update(uw);
    }

    @Override
    public ActivityAnnualAwardGiveHisDO getById(Long id) {
        return activityAnnualAwardGiveHisProvider.getById(id);
    }

    @Override
    public boolean exist(Long id) {
        return activityAnnualAwardGiveHisProvider.exist(id);
    }

    @Override
    public PageList<ActivityAnnualAwardGiveHisDO> getPageList(ActivityAnnualAwardGiveHisPageListQO qo) {
        return activityAnnualAwardGiveHisProvider.getPageList(qo);
    }

    @Override
    public Map<Long, ActivityAnnualAwardGiveHisDO> getMapByIds(Collection ids) {
        return activityAnnualAwardGiveHisProvider.getMapByIds(ids);
    }

    // 手动编码开始

}