package com.starbuds.server.service.activity.impl;

import com.starbuds.server.common.pojo.db.ActivityAnnualAwardItemDO;
import com.starbuds.server.service.activity.provider.ActivityAnnualAwardItemProvider;
import com.starbuds.server.common.pojo.activity.qo.ActivityAnnualAwardItemPageListQO;

import com.starbuds.server.common.pojo.api.PageList;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import com.starbuds.server.common.service.activity.ActivityAnnualAwardItemService;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.dubbo.config.annotation.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 周年庆奖励奖项item
 */
@Service(version = "1.0.0")
@Slf4j
public class ActivityAnnualAwardItemServiceImpl implements ActivityAnnualAwardItemService {

    @Resource
    private ActivityAnnualAwardItemProvider activityAnnualAwardItemProvider;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ActivityAnnualAwardItemDO create(ActivityAnnualAwardItemDO po) {
        return activityAnnualAwardItemProvider.create(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createBatch(List<ActivityAnnualAwardItemDO> list) {
        return activityAnnualAwardItemProvider.createBatch(list);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createOrUpdate(ActivityAnnualAwardItemDO po) {
        return activityAnnualAwardItemProvider.createOrUpdate(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean updateById(ActivityAnnualAwardItemDO po) {
        return activityAnnualAwardItemProvider.updateById(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean update(UpdateWrapper uw) {
        return activityAnnualAwardItemProvider.update(uw);
    }

    @Override
    public ActivityAnnualAwardItemDO getById(Long id) {
        return activityAnnualAwardItemProvider.getById(id);
    }

    @Override
    public boolean exist(Long id) {
        return activityAnnualAwardItemProvider.exist(id);
    }

    @Override
    public PageList<ActivityAnnualAwardItemDO> getPageList(ActivityAnnualAwardItemPageListQO qo) {
        return activityAnnualAwardItemProvider.getPageList(qo);
    }

    @Override
    public Map<Long, ActivityAnnualAwardItemDO> getMapByIds(Collection ids) {
        return activityAnnualAwardItemProvider.getMapByIds(ids);
    }

    // 手动编码开始

}