package com.starbuds.server.service.activity.impl;

import com.alibaba.fastjson.JSON;
import com.starbuds.server.common.pojo.db.ActivityGiftsRankBindDO;
import com.starbuds.server.service.activity.provider.ActivityGiftsRankBindProvider;
import com.starbuds.server.common.pojo.activity.qo.ActivityGiftsRankBindPageListQO;

import com.starbuds.server.common.pojo.api.PageList;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;

import org.springframework.beans.BeanUtils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import com.starbuds.server.common.service.activity.ActivityGiftsRankBindService;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.service.core.IdentityService;

import static com.starbuds.server.common.pojo.util.PageListUtil.buildPageListQueryWrapper;

import org.apache.dubbo.config.annotation.Service;
import org.apache.dubbo.config.annotation.Reference;
import org.springframework.transaction.annotation.Transactional;

/**
 * 多礼物活动关系榜单，按天分隔。赠送人+收礼人当天只有一条记录
 */
@Service(version = "1.0.0")
@Slf4j
public class ActivityGiftsRankBindServiceImpl implements ActivityGiftsRankBindService {

    /**
     * 主键
     */
    private String PRIMARY_KEY = "activityGiftsRankBindId";

    @Reference(version = "1.0.0")
    private IdentityService identityService;

    @Resource
    private ActivityGiftsRankBindProvider activityGiftsRankBindProvider;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ActivityGiftsRankBindDO create(ActivityGiftsRankBindDO po) {
        return activityGiftsRankBindProvider.create(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createBatch(List<ActivityGiftsRankBindDO> list) {
        return activityGiftsRankBindProvider.createBatch(list);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createOrUpdate(ActivityGiftsRankBindDO po) {
        return activityGiftsRankBindProvider.createOrUpdate(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean updateById(ActivityGiftsRankBindDO po) {
        return activityGiftsRankBindProvider.updateById(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean update(UpdateWrapper uw) {
        return activityGiftsRankBindProvider.update(uw);
    }

    @Override
    public ActivityGiftsRankBindDO getById(Long id) {
        return activityGiftsRankBindProvider.getById(id);
    }

    @Override
    public boolean exist(Long id) {
        return activityGiftsRankBindProvider.exist(id);
    }

    @Override
    public PageList<ActivityGiftsRankBindDO> getPageList(ActivityGiftsRankBindPageListQO qo) {
        return activityGiftsRankBindProvider.getPageList(qo);
    }

    @Override
    public Map<Long, ActivityGiftsRankBindDO> getMapByIds(Collection ids) {
        return activityGiftsRankBindProvider.getMapByIds(ids);
    }

    // 手动编码开始

}