package com.starbuds.server.service.activity.impl;

import com.alibaba.fastjson.JSON;
import com.starbuds.server.common.pojo.db.ActivityGiftsRankReceiveDO;
import com.starbuds.server.service.activity.provider.ActivityGiftsRankReceiveProvider;
import com.starbuds.server.common.pojo.activity.qo.ActivityGiftsRankReceivePageListQO;

import com.starbuds.server.common.pojo.api.PageList;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;

import org.springframework.beans.BeanUtils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import com.starbuds.server.common.service.activity.ActivityGiftsRankReceiveService;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.service.core.IdentityService;

import static com.starbuds.server.common.pojo.util.PageListUtil.buildPageListQueryWrapper;

import org.apache.dubbo.config.annotation.Service;
import org.apache.dubbo.config.annotation.Reference;
import org.springframework.transaction.annotation.Transactional;

/**
 * 多礼物活动收礼榜单，按天分隔。收礼人当天只有一条记录
 */
@Service(version = "1.0.0")
@Slf4j
public class ActivityGiftsRankReceiveServiceImpl implements ActivityGiftsRankReceiveService {

    /**
     * 主键
     */
    private String PRIMARY_KEY = "activityGiftsRankReceiveId";

    @Reference(version = "1.0.0")
    private IdentityService identityService;

    @Resource
    private ActivityGiftsRankReceiveProvider activityGiftsRankReceiveProvider;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ActivityGiftsRankReceiveDO create(ActivityGiftsRankReceiveDO po) {
        return activityGiftsRankReceiveProvider.create(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createBatch(List<ActivityGiftsRankReceiveDO> list) {
        return activityGiftsRankReceiveProvider.createBatch(list);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createOrUpdate(ActivityGiftsRankReceiveDO po) {
        return activityGiftsRankReceiveProvider.createOrUpdate(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean updateById(ActivityGiftsRankReceiveDO po) {
        return activityGiftsRankReceiveProvider.updateById(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean update(UpdateWrapper uw) {
        return activityGiftsRankReceiveProvider.update(uw);
    }

    @Override
    public ActivityGiftsRankReceiveDO getById(Long id) {
        return activityGiftsRankReceiveProvider.getById(id);
    }

    @Override
    public boolean exist(Long id) {
        return activityGiftsRankReceiveProvider.exist(id);
    }

    @Override
    public PageList<ActivityGiftsRankReceiveDO> getPageList(ActivityGiftsRankReceivePageListQO qo) {
        return activityGiftsRankReceiveProvider.getPageList(qo);
    }

    @Override
    public Map<Long, ActivityGiftsRankReceiveDO> getMapByIds(Collection ids) {
        return activityGiftsRankReceiveProvider.getMapByIds(ids);
    }

    // 手动编码开始

}