package com.starbuds.server.service.activity.impl;

import com.alibaba.fastjson.JSON;
import com.starbuds.server.common.pojo.db.ActivityGiftsRankSendDO;
import com.starbuds.server.service.activity.provider.ActivityGiftsRankSendProvider;
import com.starbuds.server.common.pojo.activity.qo.ActivityGiftsRankSendPageListQO;

import com.starbuds.server.common.pojo.api.PageList;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;

import org.springframework.beans.BeanUtils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import com.starbuds.server.common.service.activity.ActivityGiftsRankSendService;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.service.core.IdentityService;

import static com.starbuds.server.common.pojo.util.PageListUtil.buildPageListQueryWrapper;

import org.apache.dubbo.config.annotation.Service;
import org.apache.dubbo.config.annotation.Reference;
import org.springframework.transaction.annotation.Transactional;

/**
 * 多礼物活动赠送榜单，按天分隔。赠送人当天只有一条记录
 */
@Service(version = "1.0.0")
@Slf4j
public class ActivityGiftsRankSendServiceImpl implements ActivityGiftsRankSendService {

    /**
     * 主键
     */
    private String PRIMARY_KEY = "activityGiftsRankSendId";

    @Reference(version = "1.0.0")
    private IdentityService identityService;

    @Resource
    private ActivityGiftsRankSendProvider activityGiftsRankSendProvider;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ActivityGiftsRankSendDO create(ActivityGiftsRankSendDO po) {
        return activityGiftsRankSendProvider.create(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createBatch(List<ActivityGiftsRankSendDO> list) {
        return activityGiftsRankSendProvider.createBatch(list);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createOrUpdate(ActivityGiftsRankSendDO po) {
        return activityGiftsRankSendProvider.createOrUpdate(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean updateById(ActivityGiftsRankSendDO po) {
        return activityGiftsRankSendProvider.updateById(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean update(UpdateWrapper uw) {
        return activityGiftsRankSendProvider.update(uw);
    }

    @Override
    public ActivityGiftsRankSendDO getById(Long id) {
        return activityGiftsRankSendProvider.getById(id);
    }

    @Override
    public boolean exist(Long id) {
        return activityGiftsRankSendProvider.exist(id);
    }

    @Override
    public PageList<ActivityGiftsRankSendDO> getPageList(ActivityGiftsRankSendPageListQO qo) {
        return activityGiftsRankSendProvider.getPageList(qo);
    }

    @Override
    public Map<Long, ActivityGiftsRankSendDO> getMapByIds(Collection ids) {
        return activityGiftsRankSendProvider.getMapByIds(ids);
    }

    // 手动编码开始

}