package com.starbuds.server.service.activity.impl;

import com.alibaba.fastjson.JSON;
import com.starbuds.server.common.pojo.db.ActivityGiftsSaveHisDO;
import com.starbuds.server.service.activity.provider.ActivityGiftsSaveHisProvider;
import com.starbuds.server.common.pojo.activity.qo.ActivityGiftsSaveHisPageListQO;

import com.starbuds.server.common.pojo.api.PageList;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;

import org.springframework.beans.BeanUtils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import com.starbuds.server.common.service.activity.ActivityGiftsSaveHisService;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.service.core.IdentityService;

import static com.starbuds.server.common.pojo.util.PageListUtil.buildPageListQueryWrapper;

import org.apache.dubbo.config.annotation.Service;
import org.apache.dubbo.config.annotation.Reference;
import org.springframework.transaction.annotation.Transactional;

/**
 * 多礼物活动保存记录（保证幂等）
 */
@Service(version = "1.0.0")
@Slf4j
public class ActivityGiftsSaveHisServiceImpl implements ActivityGiftsSaveHisService {

    /**
     * 主键
     */
    private String PRIMARY_KEY = "hisId";

    @Reference(version = "1.0.0")
    private IdentityService identityService;

    @Resource
    private ActivityGiftsSaveHisProvider activityGiftsSaveHisProvider;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ActivityGiftsSaveHisDO create(ActivityGiftsSaveHisDO po) {
        return activityGiftsSaveHisProvider.create(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createBatch(List<ActivityGiftsSaveHisDO> list) {
        return activityGiftsSaveHisProvider.createBatch(list);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean createOrUpdate(ActivityGiftsSaveHisDO po) {
        return activityGiftsSaveHisProvider.createOrUpdate(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean updateById(ActivityGiftsSaveHisDO po) {
        return activityGiftsSaveHisProvider.updateById(po);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean update(UpdateWrapper uw) {
        return activityGiftsSaveHisProvider.update(uw);
    }

    @Override
    public ActivityGiftsSaveHisDO getById(Long id) {
        return activityGiftsSaveHisProvider.getById(id);
    }

    @Override
    public boolean exist(Long id) {
        return activityGiftsSaveHisProvider.exist(id);
    }

    @Override
    public PageList<ActivityGiftsSaveHisDO> getPageList(ActivityGiftsSaveHisPageListQO qo) {
        return activityGiftsSaveHisProvider.getPageList(qo);
    }

    @Override
    public Map<Long, ActivityGiftsSaveHisDO> getMapByIds(Collection ids) {
        return activityGiftsSaveHisProvider.getMapByIds(ids);
    }

    // 手动编码开始

}