package com.starbuds.server.service.activity.impl;

import com.starbuds.server.common.constant.activity.TriggerEventEnum;
import com.starbuds.server.common.pojo.activity.BaseEventParam;
import com.starbuds.server.common.service.activity.TriggerService;
import com.starbuds.server.service.activity.provider.TriggerProvider;
import org.apache.dubbo.config.annotation.Service;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 触发器服务实现
 *
 * @author Lay
 * @date 2020/1/13
 */
@Service(version = "1.0.0")
public class TriggerServiceImpl implements TriggerService {

    @Autowired
    TriggerProvider triggerProvider;

    /**
     * 事件触发
     *
     * @param triggerEvent
     * @param eventParam
     * @return
     */
    @Override
    public boolean emitEvent(TriggerEventEnum triggerEvent, BaseEventParam eventParam) {
        // 异步事件处理
        triggerProvider.handleEventAsync(triggerEvent, eventParam);
        return true;
    }
}
