package com.starbuds.server.service.activity.impl;

import com.alibaba.fastjson.JSON;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.db.UserActivitiesLevelHisDO;
import com.starbuds.server.common.service.core.IdentityService;
import com.starbuds.server.service.activity.dao.UserActivitiesLevelHisDAO;
import lombok.extern.slf4j.Slf4j;

import javax.annotation.Resource;

import com.starbuds.server.common.service.activity.UserActivitiesLevelHisService;

import org.apache.dubbo.config.annotation.Reference;
import org.apache.dubbo.config.annotation.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 */
@Service(version = "1.0.0")
@Slf4j
public class UserActivitiesLevelHisServiceImpl implements UserActivitiesLevelHisService {

    /**
     * 主键
     */
    private String PRIMARY_KEY = "hisId";

    @Reference(version = "1.0.0")
    private IdentityService identityService;

    @Resource
    private UserActivitiesLevelHisDAO userActivitiesLevelHisDAO;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public UserActivitiesLevelHisDO create(UserActivitiesLevelHisDO po) {
        po.setHisId(identityService.getId());
        po.setCreateTime(System.currentTimeMillis());
        boolean flag = userActivitiesLevelHisDAO.insert(po) == 1;

        String json = JSON.toJSONString(po);
        if (flag) {
            log.info("创建成功 {}", json);
            return po;
        }
        log.warn("创建失败 {}", json);
        return null;
    }

    @Override
    public UserActivitiesLevelHisDO getUserLevel(Long userId, Integer scoreType) {
        if (userId == null || scoreType == null) {
            return null;
        }
        QueryWrapper qw = new QueryWrapper();
        qw.eq("userId", userId);
        qw.eq("scoreType", scoreType);
        return userActivitiesLevelHisDAO.selectUserLevel(qw);
    }

}