package com.starbuds.server.service.activity.pojo.bo;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.ToString;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * 抽奖游戏中奖通知
 *
 * @author aoe
 * @date 2022/1/5
 */
@Builder
@ToString
@Getter
public class LotteryGameWinNoticeMsg {

    /**
     * 物品名称
     */
    @NotBlank(message = "itemName 不能为 blank")
    private String itemName;

    /**
     * 物品数量
     */
    @NotNull(message = "quantity 不能为 null")
    private Integer quantity;

    /**
     * 物品价值
     */
    @NotNull(message = "itemValue 不能为 null")
    private Long itemValue;

    /**
     * 背包主人id
     */
    @NotNull(message = "userId 不能为 null")
    private Long userId;

    /**
     * 中奖通知类型 LotteryGameWinNoticeTypeEnum
     */
    private Integer winNoticeType;
}
