package com.starbuds.server.service.activity.redpacket;

import lombok.Data;

import java.math.BigDecimal;

/**
 * 备注
 *
 * @author Lay
 * @date 2021/3/29
 */
@Data
public class RedPacketsConfig {
    /**
     * 手气最佳红包的金额占总金额大小的比例，取值范围 [0.5,1)，默认是0.9
     * 注意点1 ： 当前算法不支持小于 0.5 的取值
     * 注意点2 ： 因为有最新金额 0.01 元限制，如果 0.03元红包被两人份，手气最佳天然占比66.67%，没法做到50%
     */
    private BigDecimal luckLimit = new BigDecimal("0.9");

    /**
     * 分红包时每人分到手的最小金额，默认是一分钱。
     */
    private BigDecimal minAvgMoney = new BigDecimal("0.01");

    /**
     * 金额精确到小数点后的位数，默认是小数点后两位，精确到0.01元。
     */
    private int moneyScale = 2;

    /**
     * 除法默认精度
     */
    private int defaultScale = 10;
}
