package com.starbuds.server.service.activity.rocket.listener;

import com.alibaba.fastjson.JSON;
import com.aliyun.openservices.ons.api.Action;
import com.aliyun.openservices.ons.api.ConsumeContext;
import com.aliyun.openservices.ons.api.Message;
import com.aliyun.openservices.ons.api.MessageListener;
import com.starbuds.server.common.constant.rocketmq.RocketTag;
import com.starbuds.server.common.pojo.mq.*;
import com.starbuds.server.service.activity.rocket.handler.DelayMsgHandler;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * 备注
 *
 * @author Lay
 * @date 2020/12/28
 */
@Component
@Slf4j
public class DelayMsgListener implements MessageListener {

    @Resource
    DelayMsgHandler delayMsgHandler;

    @Override
    public Action consume(Message message, ConsumeContext context) {
        log.info("收到延迟队列消息 {} {}", message.getTopic(), message.getTag());
        try {
            switch (message.getTag()) {
                case RocketTag.HEADLINE_LOTTERY_PERIOD_OVER:
                    // 礼物支付消息
                    delayMsgHandler.handleHeadlineLotteryPeriodOver(JSON.parseObject(message.getBody(), QueueHeadlineLotteryPeriodOverMsg.class));
                    break;
                default:
                    break;
            }
        } catch (Exception e) {
            log.error("消息处理失败", e);
            return Action.ReconsumeLater;
        }
        return Action.CommitMessage;
    }
}
