package com.starbuds.server.service.activity.util;

import com.starbuds.server.common.utils.DateUtil;

/**
 * 时间工具类
 *
 * @author aoe
 * @date 2021/11/25
 */
public class TimeUtil {

    /**
     * 是否等于目标时间
     *
     * @param target 目标时间
     * @param now    当前时间
     * @return
     */
    public final static boolean equalsTargetTime(long target, long now) {
        return DateUtil.toFullTime(target).equals(DateUtil.toFullTime(now));
    }

    /**
     * 当前时间
     *
     * @param now 当前时间
     * @return yyyy-MM-dd HH:mm:ss
     */
    public final static String currentStr(long now) {
        return DateUtil.toFullTime(now);
    }

    public static void main(String[] args) {
        System.out.println(DateUtil.toYearMonthDayHourMinute(1638261900000L));
    }
}
