package com.starbuds.server.service.activity.lotterygame;

import com.starbuds.server.common.pojo.db.LotteryGameSnapshotDO;
import com.starbuds.server.service.activity.lotterygame.task.SendCountdownNoticeTask;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.test.util.ReflectionTestUtils;
import test.BaseTest;

import javax.annotation.Resource;

class SendCountdownNoticeTaskTest extends BaseTest {

    @Resource
    private SendCountdownNoticeTask sendCountdownNoticeTask;

    @Test
    void sendNotice() {
        LotteryGameSnapshotDO snap = new LotteryGameSnapshotDO();
        snap.setSnapId(1L);
        snap.setStartTime(System.currentTimeMillis() + (600 * 1000));
        snap.setNotice("红包雨将于#分钟#后到达，各就各位！");
        snap.setCountDown(600L);
        Assertions.assertTrue(sendNotice(snap));
    }

    private boolean sendNotice(LotteryGameSnapshotDO snap) {
        return ReflectionTestUtils.invokeMethod(sendCountdownNoticeTask, "sendNotice", snap);
    }
}