package com.starbuds.server.service.activity.util;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

class TimeUtilTest {

    @Test
    void equalsTargetTime() {
        final long target = 1637834120000L;
        Assertions.assertTrue(TimeUtil.equalsTargetTime(target, 1637834120000L));
        Assertions.assertTrue(TimeUtil.equalsTargetTime(target, 1637834120999L));
        Assertions.assertTrue(TimeUtil.equalsTargetTime(target, 1637834120100L));
        Assertions.assertTrue(TimeUtil.equalsTargetTime(target, 1637834120020L));
        Assertions.assertTrue(TimeUtil.equalsTargetTime(target, 1637834120001L));
        for (int i = 1; i < 1000; i++) {
            Assertions.assertTrue(TimeUtil.equalsTargetTime(target, target + i));
        }

        Assertions.assertFalse(TimeUtil.equalsTargetTime(target, 1637834121000L));
        Assertions.assertFalse(TimeUtil.equalsTargetTime(target, 1637808920000L));
        Assertions.assertFalse(TimeUtil.equalsTargetTime(target, 1637895320000L));
        for (int i = 1000; i < 10000; i++) {
            Assertions.assertFalse(TimeUtil.equalsTargetTime(target, target + i));
        }
        for (int i = 0; i < 10000; i++) {
            Assertions.assertFalse(TimeUtil.equalsTargetTime(target, 1637376920000L + i));
        }
    }

}